angular.module('mm.addons.mod_tutorialbooking', ['mm.core'])
.constant('mmaModTutorialbookingComponent', 'mmaModTutorialbooking')
.config(["$stateProvider", function($stateProvider) {
    $stateProvider
    .state('site.mod_tutorialbooking', {
        url: '/mod_tutorialbooking',
        params: {
            module: null,
            courseid: null
        },
        views: {
            'site': {
                controller: 'mmaModTutorialbookingSlotsCtrl',
                templateUrl: '$ADDONPATH$/templates/slots.html'
            }
        }
    });
}])
.config(["$mmCourseDelegateProvider", "$mmContentLinksDelegateProvider", function($mmCourseDelegateProvider, $mmContentLinksDelegateProvider) {
    $mmCourseDelegateProvider.registerContentHandler('mmaModTutorialbooking', 'tutorialbooking', '$mmaModTutorialbookingHandlers.courseContent');
    $mmContentLinksDelegateProvider.registerLinkHandler('mmaModTutorialbooking:index', '$mmaModTutorialbookingHandlers.indexLinksHandler');
}]);
angular.module('mm.addons.mod_tutorialbooking')
.controller('mmaModTutorialbookingSlotsCtrl', ["$scope", "$stateParams", "$mmCourse", "mmUserProfileState", "mmaModTutorialbookingComponent", "$mmaModTutorialbooking", "$mmUtil", "$mmText", "$translate", function($scope, $stateParams, $mmCourse, mmUserProfileState,
    mmaModTutorialbookingComponent, $mmaModTutorialbooking, $mmUtil, $mmText, $translate) {
    var module = $stateParams.module || {},
        courseid = $stateParams.courseid,
        tutorialbooking;
    $scope.tutorialbookingLoaded = false;
    $scope.capabilitiesLoaded = false;
    $scope.moduleUrl = module.url;
    $scope.moduleName = $mmCourse.translateModuleName('tutorialbooking');
    $scope.courseid = courseid;
    $scope.instance = module.instance;
    $scope.userStateName = mmUserProfileState;
    $scope.component = mmaModTutorialbookingComponent;
    $scope.componentId = module.id;
    $scope.refreshIcon = 'spinner';
    $scope.title = module.name;
    $scope.description = module.description;
    $scope.canSignup = false;
    $scope.locked = false;
    $scope.privacy = 1;
    $scope.signedup = false;
    $scope.displaySignup = function(slot) {
        return !$scope.signedup && !$scope.locked && $scope.freespaces(slot) > 0;
    };
    $scope.displayRemoveSignup = function(slot) {
        return $scope.signedup && slot.signedup &&!$scope.locked;
    };
    $scope.freeBadgeClass = function(slot) {
        var freespaces = slot.spaces - slot.usedspaces;
        var classname;
        if (freespaces < 1) {
            classname = 'badge-assertive';
        } else {
            classname = 'badge-balanced';
        }
        return classname;
    };
    $scope.freespaces = function(slot) {
        var freespaces = slot.spaces - slot.usedspaces;
        if (freespaces < 0) {
            freespaces = 0;
        }
        return freespaces;
    };
    $scope.refresh = refreshData;
    $scope.expandDescription = function() {
        $mmText.expandText($translate.instant('mm.core.description'), $scope.description, false,
                    mmaModTutorialbookingComponent, module.id);
    };
    $scope.removeSignup = function (id) {
        return $mmaModTutorialbooking.removeSignup(id).then(refreshData).catch(function(message) {
            $mmUtil.showErrorModalDefault(message, 'mma.mod_tutorialbooking.cannotremove', true);
            return refreshData();
        });
    };
    $scope.signup = function (id) {
        return $mmaModTutorialbooking.signup(id).then(refreshData).catch(function(message) {
            $mmUtil.showErrorModalDefault(message, 'mma.mod_tutorialbooking.cannotsignup', true);
            return refreshData();
        });
    };
    $mmaModTutorialbooking.getCapabilities(module.instance).then(processCapabilities);
    loadData();
    function loadData() {
        return $mmaModTutorialbooking.getData($scope.instance).then(processData).catch(function(message) {
            $mmUtil.showErrorModalDefault(message, 'mma.mod_tutorialbooking.cannotload', true);
        }).finally(logview);
   }
   function logview() {
        $mmaModTutorialbooking.logView(module.instance).then(function() {
            $mmCourse.checkModuleCompletion(courseid, module.completionstatus);
        });
   }
   function refreshData() {
        $scope.tutorialbookingLoaded = false;
        $scope.refreshIcon = 'spinner';
        return $mmaModTutorialbooking.refreshData($scope.instance).then(processData).catch(function(message) {
            $mmUtil.showErrorModalDefault(message, 'mma.mod_tutorialbooking.cannotload', true);
        }).finally(refreshCompleted);
   }
   function refreshCompleted() {
       $scope.$broadcast('scroll.refreshComplete');
   }
    function processData(tutorialbooking) {
        $scope.title = tutorialbooking.title || $scope.title;
        $scope.description = tutorialbooking.intro || $scope.description;
        $scope.privacy = tutorialbooking.privacy;
        $scope.signedup = tutorialbooking.signedup;
        $scope.locked = tutorialbooking.locked;
        $scope.slots = tutorialbooking.slots || [];
        $scope.refreshIcon = 'ion-refresh';
        $scope.tutorialbookingLoaded = true;
    }
    function processCapabilities(capabilities) {
        $scope.canSignup = capabilities.submit;
        $scope.capabilitiesLoaded = true;
    }
}]);
angular.module('mm.addons.mod_tutorialbooking')
.factory('$mmaModTutorialbookingHandlers', ["$state", "$mmContentLinksHelper", "$mmaModTutorialbooking", function($state, $mmContentLinksHelper, $mmaModTutorialbooking) {
    var self = {};
    self.courseContent = function() {
        var self = {};
        self.isEnabled = function() {
            return $mmaModTutorialbooking.isPluginEnabled();
        };
        self.getController = function(module, courseId) {
            return function($scope) {
                $scope.title = module.name;
                $scope.icon = '$ADDONPATH$/img/icon.svg';
                $scope.class = 'mma-mod_tutorialbooking-handler';
                $scope.spinner = false;
                $scope.action = function(e) {
                    if (e) {
                        e.preventDefault();
                        e.stopPropagation();
                    }
                    $state.go('site.mod_tutorialbooking', {module: module, courseid: courseId});
                };
            };
        };
        return self;
    };
    self.indexLinksHandler = $mmContentLinksHelper.createModuleIndexLinkHandler('mmaModTutorialbooking', 'tutorialbooking', $mmaModTutorialbooking);
    return self;
}]);
angular.module('mm.addons.mod_tutorialbooking')
.factory('$mmaModTutorialbooking', ["$mmSite", "$q", "$mmSitesManager", "$mmUtil", function($mmSite, $q, $mmSitesManager, $mmUtil) {
    var self = {};
    function capabilitiesCacheKey(tutorialid) {
        return 'mmaModTutorialbooking:capabilities:' + tutorialid;
    }
    function tutorialbookingDataCacheKey(tutorialid) {
        return 'mmamodTutorialbooking:tutorial:' + tutorialid;
    }
    self.getCapabilities = function(tutorialid) {
        var params = {
                id: tutorialid
            },
            preSets = {
                cacheKey: capabilitiesCacheKey(tutorialid)
            };
        return $mmSite.read('mod_tutorialbooking_capabilities', params, preSets).then(function(result) {
            if (result) {
                return result;
            }
            return $q.reject();
        });
    };
    self.refreshData = function(tutorialid) {
        return $mmSite.invalidateWsCacheForKey(tutorialbookingDataCacheKey(tutorialid)).then(function() {
            return self.getData(tutorialid);
        });
    };
    self.getData = function(tutorialid) {
        var params = {
                id: tutorialid
            },
            preSets = {
                cacheKey: tutorialbookingDataCacheKey(tutorialid)
            };
        return $mmSite.read('mod_tutorialbooking_details', params, preSets).then(function(result) {
            if (result) {
                return result;
            }
            return $q.reject();
        });
    };
    self.signup = function(slotid) {
        var signupparams = {
                slotid: slotid
            };
        return $mmSite.write('mod_tutorialbooking_signup', signupparams).then(function(response) {
                if (response.success === true) {
                    return response.success;
                }
                return $q.reject({
                    error: response.error.message
                });
            });
    };
    self.removeSignup = function(slotid) {
        var removeparams = {
                slotid: slotid
            };
        return $mmSite.write('mod_tutorialbooking_remove_signup', removeparams).then(function(response) {
                if (response.success === true) {
                    return response.success;
                }
                return $q.reject({
                    error: response.error.message
                });
            });
    };
    self.logView = function(tutorialid) {
        var viewparams = {
                id: tutorialid
            };
        return $mmSite.write('mod_tutorialbooking_view_tutorialbooking', viewparams);
    };
    self.isPluginEnabled = function(siteId) {
        siteId = siteId || $mmSite.getId();
        return $mmSitesManager.getSite(siteId).then(function(site) {
            return  site.wsAvailable('mod_tutorialbooking_view_tutorialbooking') &&
                    site.wsAvailable('mod_tutorialbooking_details') &&
                    site.wsAvailable('mod_tutorialbooking_signup') &&
                    site.wsAvailable('mod_tutorialbooking_remove_signup') &&
                    site.wsAvailable('mod_tutorialbooking_capabilities');
        });
    };
    return self;
}]);
